- Qt 5.15
- Qt Data Visualization
- C++ Classes
- QBar3DSeries
- Qt Data Visualization | Commercial or GPLv3

# QBar3DSeries Class

The QBar3DSeries class represents a data series in a 3D bar graph. More...

Header: | #include <QBar3DSeries>
qmake: | QT += datavisualization
Since: | QtDataVisualization 1.0
Instantiated By: | Bar3DSeries
Inherits: | QAbstract3DSeries

This class was introduced in QtDataVisualization 1.0.

- List of all members, including inherited members

## Properties

- dataProxy : QBarDataProxy*
- meshAngle : float
- selectedBar : QPoint

## Public Functions

| QBar3DSeries(QBarDataProxy *dataProxy, QObject *parent = nullptr)
| QBar3DSeries(QObject *parent = nullptr)
virtual | ~QBar3DSeries()
QBarDataProxy * | dataProxy() const
float | meshAngle() const
QPoint | selectedBar() const
void | setDataProxy(QBarDataProxy *proxy)
void | setMeshAngle(float angle)
void | setSelectedBar(const QPoint &position)

## Signals

void | dataProxyChanged(QBarDataProxy *proxy)
void | meshAngleChanged(float angle)
void | selectedBarChanged(const QPoint &position)

## Static Public Members

QPoint | invalidSelectionPosition()

## Detailed Description

This class manages the series specific visual elements, as well as the series data (via a data proxy).

If no data proxy is set explicitly for the series, the series creates a default proxy. Setting another proxy will destroy the existing proxy and all data added to it.

QBar3DSeries supports the following format tags for QAbstract3DSeries::setItemLabelFormat():

@rowTitle | Title from row axis
@colTitle | Title from column axis
@valueTitle | Title from value axis
@rowIdx | Visible row index. Localized using the graph locale.
@colIdx | Visible column index. Localized using the graph locale.
@rowLabel | Label from row axis
@colLabel | Label from column axis
@valueLabel | Item value formatted using the format of the value axis attached to the graph. For more information, see QValue3DAxis::labelFormat.
@seriesName | Name of the series
%<format spec> | Item value in the specified format. Formatted using the same rules as QValue3DAxis::labelFormat.

For example:

     proxy->setItemLabelFormat(QStringLiteral("@valueTitle for (@rowLabel, @colLabel): %.1f"));

See also Qt Data Visualization Data Handling and QAbstract3DGraph::locale.

## Property Documentation

### dataProxy : QBarDataProxy*

This property holds the active data proxy.

The series assumes ownership of any proxy set to it and deletes any previously set proxy when a new one is added. The proxy cannot be null or set to another series.

Access functions:

QBarDataProxy * | dataProxy() const
void | setDataProxy(QBarDataProxy *proxy)

Notifier signal:

void | dataProxyChanged(QBarDataProxy *proxy)

### meshAngle : float

This property holds the series rotation angle in degrees.

Setting this property is equivalent to the following call:

     setMeshRotation(QQuaternion::fromAxisAndAngle(0.0f, 1.0f, 0.0f, angle))

Note: When reading this property, it is calculated from the QAbstract3DSeries::meshRotation value using floating point precision and always returns a value from zero to 360 degrees.

Access functions:

float | meshAngle() const
void | setMeshAngle(float angle)

Notifier signal:

void | meshAngleChanged(float angle)

See also QAbstract3DSeries::meshRotation.

### selectedBar : QPoint

This property holds the bar in the series that is selected.

Access functions:

QPoint | selectedBar() const
void | setSelectedBar(const QPoint &position)

Notifier signal:

void | selectedBarChanged(const QPoint &position)

## Member Function Documentation

### QBar3DSeries::QBar3DSeries(QBarDataProxy *dataProxy, QObject *parent = nullptr)

Constructs a bar 3D series with the data proxy dataProxy and the parent parent.

### QBar3DSeries::QBar3DSeries(QObject *parent = nullptr)

Constructsa bar 3D series with the parent parent.

### `[virtual]` QBar3DSeries::~QBar3DSeries()

Deletes a bar 3D series.

### `[static]` QPoint QBar3DSeries::invalidSelectionPosition()

Returns an invalid position for selection. This position is set to the selectedBar property to clear the selection from this series.

See also QAbstract3DGraph::clearSelection().

### void QBar3DSeries::setSelectedBar(const QPoint &position)

Selects the bar at the position position, specified as a row and column in the data array of the series.

Only one bar can be selected at a time.

To clear selection from this series, invalidSelectionPosition() is set as position.

If this series is added to a graph, the graph can adjust the selection according to user interaction or if it becomes invalid. Selecting a bar on another added series will also clear the selection.

Removing rows from or inserting rows to the series before the row of the selected bar will adjust the selection so that the same bar will stay selected.

Note: Setter function for property selectedBar.

See also selectedBar() and QAbstract3DGraph::clearSelection().